/*
 * Bluecell_operate.h
 *
 *  Created on: 2020. 4. 3.
 *      Author: YJ
 */

#ifndef BLUECELL_OPERATE_H_
#define BLUECELL_OPERATE_H_


#include <stdbool.h>
#include "Bluecell_operate.h"
/*
SYN
Sub-UID
R-Code
TR-ID
Seq-Num
TTL
Time
 
CMD
Length
Header Checksum
SUB-DATA
SUB-DATA-CRC
ETX
 */


/*
 *
0	80	ü  ȸ	 AID ׸   û   (û Frame SUB-DATA  ̴ 0)
1	81	 û	 û REQ 0x01 ̰  ü  ¸ 

10	90	Download Notification	ٿε 
11	91	Download Data	ٿε data
12	92	Download Confirm	ٿε Ȯ
13	93	Download Complete	Download Complete Command
14	94	System-Reboot	System Rebooting Command

40	C0	̺ ȸ  
41	C1	̺   

 *
 *
 */
typedef enum{
	AllDataReq = 0,      // -> Response 80
	DataCtrlReq,		 // -> Response 81
	DownNotification,    // -> Response 90
	DownData,            // -> Response 91
	DownConfirm ,        // -> Response 92
	DownComplete,        // -> Response 93
	SystemReboot,        // -> Response 94

	TableDataReq = 40,

};

typedef enum{
	MBIC_PREAMBLE_0 = 0,
	MBIC_PREAMBLE_1,
	MBIC_PREAMBLE_2,
	MBIC_PREAMBLE_3,
	MBIC_SUBUID_0,
	MBIC_SUBUID_1,
	MBIC_RCODE_0,
	MBIC_TRID_0,
	MBIC_TRID_1,
	MBIC_SEQSUM_0, // 10byte
	MBIC_TTL_0,
	MBIC_TIME_0,
	MBIC_TIME_1,
	MBIC_TIME_2,
	MBIC_TIME_3,
	MBIC_TIME_4,
	MBIC_TIME_5,
	MBIC_ERRRESPONSE_0,
	MBIC_CMD_0,
	MBIC_LENGTH_0, // 20byte
	MBIC_LENGTH_1,
	MBIC_HEADERCHECKSUM_0,
	MBIC_PAYLOADSTART,
	/*
	 * PayLoadSTART
	 */
};
#define MBIC_PREAMBLE0 0x16
#define MBIC_PREAMBLE1 0x16
#define MBIC_PREAMBLE2 0x16
#define MBIC_PREAMBLE3 0x16
#define MBIC_SUBUID0 0x00
#define MBIC_SUBUID1 0xF1
#define MBIC_RCODE
#define MBIC_TRID
#define MBIC_SEQNUM
#define MBIC_TTL
#define MBIC_TIME
#define MBIC_ERRRESPONSE
#define MBIC_CMD
#define MBIC_LENGTH
#define MBIC_CHECKSHUM
#define MBIC_ETX 0x03

#endif /* BLUECELL_OPERATE_H_ */
